;
; GG Nibbles
; Fourth release
; Memory management include file
;
;--- FILL MEMORY ------------------------------------------------------------
;--- B = bytes to clear   A = fillbyte   HL = address -----------------------
; Note: This routine can only fill up to 256 bytes
;       because the counter is only one byte.
FILL_MEM:
  ld (HL),a
  inc hl
  dec b
  jr NZ, FILL_MEM
  ret
;--- COPY MEMORY ------------------------------------------------------------
;--- C = bytes to copy   IX = source address   HL = destination address -----
; Note: This routine can only copy up to 256 bytes
;       because the counter is only one byte.
COPY_MEM:
  ld a, (IX)
  ld (HL),a
  inc hl
  inc ix
  dec c
  jr NZ, COPY_MEM
  ret
;--- COPY MEMORY BACKWARDS --------------------------------------------------
;--- C = bytes to clear   IX = source address   HL = destination address ----
; Note: This routine can only copy up to 256 bytes
;       because the counter is only one byte.
COPY_MEM_BACKWARDS:
  ld b, 0
  add hl, bc
  dec hl
  add ix, bc
  dec ix
COPY_MEM_BACKWARDS_LOOP:
  ld a, (IX)
  ld (HL),a
  dec hl
  dec ix
  dec c
  jr NZ, COPY_MEM_BACKWARDS_LOOP
  ret
